-- Abandon Ship Options.lua

EB_BAG = -1;
EB_SLOT = -1;

local function dout(msg)
	if( DEFAULT_CHAT_FRAME and EB_DEBUG == 1) then
		DEFAULT_CHAT_FRAME:AddMessage(msg,1.0,0,0);
	end
end

function EBOptionsItem_OnClick(arg1)
	if arg1 == "LeftButton" then
		if CursorHasItem() then
			--AbandonShipOptions.bag = EB_BAG;
			--AbandonShipOptions.slot = EB_SLOT;
			
			local itemName = EB_GetItemName(EB_BAG,EB_SLOT);
				
			EB_FindAndSetButtonTexture(itemName);

			AbandonShipOptions.itemName = itemName;
			AbandonShipOptions[EB_SAVE_PREFIX.."itemName"] = itemName;
			
			ResetCursor();
			EB_TakeItemOffCursor(EB_BAG,EB_SLOT);
		end  -- if has item and we know where it came from
	end  -- if left button
end

function EBOptionsItem_OnDragStart()

end

function EBOptionsItem_OnReceiveDrag()
	EBOptionsItem_OnClick("LeftButton");
end

function EBOptionsItem_OnEnter()
	if this.itemName and this.itemName ~= "" then
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
		
		local bag,slot = EB_FindItem(this.itemName);
		if bag and slot then
			if bag == -1 then
				GameTooltip:SetInventoryItem("player", slot);
			else
				GameTooltip:SetBagItem(bag,slot);
			end
		else
			GameTooltip:SetText(this.itemName, 1.0, 1.0, 1.0);
		end
		
		GameTooltip:Show();
	end
end

function EBOptionsFrame_OnLoad()
	EBOptions_DoLocalization();	
end


function EBOptionsCheckButton_OnClick()
	if (this == EBOptionsBoatsAndZepplinsCheckButton) then
		AbandonShipOptions.boatsAndZepplins = this:GetChecked();
		this:SetChecked(AbandonShipOptions.boatsAndZepplins);
	elseif (this == EBOptionsTramCheckButton) then
		AbandonShipOptions.tram = this:GetChecked();
		this:SetChecked(AbandonShipOptions.tram);
		if (AbandonShipOptions.tram == 1 and EB_TRAM_MODE == 1) then
			EB_NotifyFrame:Show();
		else
			EB_NotifyFrame:Hide();
		end
	elseif (this == EBOptionsAttackedCheckButton) then
		AbandonShipOptions.attacked = this:GetChecked();
		this:SetChecked(AbandonShipOptions.attacked);
	elseif (this == EBOptionsUseThisCheckButton) then
		AbandonShipOptions.useItem = this:GetChecked();
		this:SetChecked(AbandonShipOptions.useItem);
	end
end

function EBOptionsFrame_OnShow()
	if (AbandonShipOptions ~= nil) then
		dout("OnShow: "..AbandonShipOptions.tram);
		EB_FindAndSetButtonTexture(AbandonShipOptions.itemName);
		
		EBOptionsBoatsAndZepplinsCheckButton:SetChecked(AbandonShipOptions.boatsAndZepplins);
		EBOptionsTramCheckButton:SetChecked(AbandonShipOptions.tram);
		EBOptionsAttackedCheckButton:SetChecked(AbandonShipOptions.attacked);
		EBOptionsUseThisCheckButton:SetChecked(AbandonShipOptions.useItem);
	end
end

function EBOptionsFrame_OnHide()

end

function EB_GetItemName(bag, slot)
	local linktext = nil;

	linktext = GetContainerItemLink(bag, slot);
	
	if linktext then
		local _,_,name = string.find(linktext, "^.*%[(.*)%].*$");
		return name;
	else
		return "";
	end
end

function EB_TakeItemOffCursor(srcBag, srcSlot)
	PickupContainerItem(srcBag, srcSlot);
end

function EB_SetButtonTextureAndName(texture,itemName)
	local btn = getglobal("EBItemToUseButton");
	if btn then
		SetItemButtonTexture(btn, texture);
		btn.itemName = itemName;
	end
end

function EB_FindAndSetButtonTexture(itemName)
	if itemName and itemName ~= "" then
		local bag, slot = EB_FindItem(itemName);
		if bag and slot then
			local texture;
			texture = GetContainerItemInfo(bag, slot);
			EB_SetButtonTextureAndName(texture, itemName);
		else
			-- if not found, just use a generic icon
			EB_SetButtonTextureAndName("Interface\\Icons\\INV_Misc_Gift_01", itemName);
		end
	else
		-- no item name, no icon
		EB_SetButtonTextureAndName(nil, itemName);
	end
end

function EB_FindItem(name, skipcount)
	skipcount = skipcount or 0;
	
	for i=NUM_BAG_FRAMES,0,-1 do
		for j=GetContainerNumSlots(i),1,-1 do
			if (EB_GetItemName(i,j) == name) then 
				if skipcount == 0 then 
					return i,j; 
				end
				skipcount = skipcount - 1;
			end
		end
	end
end


local EB_Save_PickupContainerItem = PickupContainerItem;
PickupContainerItem = function (bag,slot)
	dout("bag: "..bag..", slot: "..slot);
	EB_BAG = bag;
	EB_SLOT = slot;
	--AbandonShipOptions.bag = bag;
	--AbandonShipOptions.slot = slot;

	return EB_Save_PickupContainerItem(bag,slot);
end


function EB_OnOK()
	EBOptionsFrame:Hide();
end