function vector(x, y)
   if type(x) == "table" then
      local v;
      v = { };
      v.x = x.x;
      v.y = x.y;
      return v;
   end

   if x == nil then x = 0; end
   if y == nil then y = 0; end

   local v = { };
   v.x = x;
   v.y = y;
   return v;
end

function neg(vx,vy)
   --local v1 = vector(v);
   local v1x,v1y;
   v1x = -vx;
   v1y = -vy;
   return v1x,v1y;
end

function zero(vx,vy)
   return vx == 0 and vy == 0;
end

function dist2(vx,vy)
   return vx * vx + vy * vy;
end

function dist(vx,vy)
   return sqrt(dist2(vx,vy));
end

function dotprod(v1x,v1y,v2x,v2y)
   return v1x * v2x + v1y * v2y;
end

function crossprod(v1x,v1y,v2x,v2y)
   return v1x * v2y - v2x * v1y;
end

function normalize(vx,vy)
   --local v2 = vector(v);
   local v2x = vx;
   local v2y = vy;

   local d = dist(v2x,v2y);
   if d == 0 then return v2x,v2y; end
   v2x = v2x / d;
   v2y = v2y / d;
   return v2x,v2y;
end

function copy(v1x,v1y, v2x,v2y)
   v1x = v2x;
   v1y = v2y;
end

function vector_tostring(vx,vy)
   return format("(%.6f, %.6f)", vx, vy);
end

function sum(v1x,v1y, v2x,v2y)
   --local v = vector();
   local vx,vy;
   vx = v1x + v2x;
   vy = v1y + v2y;
   return vx,vy;
end

function difference(v1x,v1y,v2x,v2y)
   --local v = vector();
   local x,y;

   x = v1x - v2x;
   y = v1y - v2y;
   return x,y;
end

function product(k, v1x,v1y)
   --local v = vector();
	local vx,vy;

   vx = k * v1x;
   vy = k * v1y;
   return vx,vy;
end

function rotate(v1x,v1y,degrees)
	--local v = vector();
	local vx,vy;
	vx = (cos(degrees) * v1x) - (sin(degrees) * v1y);
	vy = (cos(degrees) * v1y) + (sin(degrees) * v1x);
	return vx,vy;
end

function tangetpointonline( pointX, pointY, linestartX, linestartY, lineendX, lineendY )
    local lineDistance;
    local U;
    --local intersectionPoint = vector();
	local intersectionPointX, intersectionPointY;
 
    lineDistance = dist(difference(lineendX, lineendY, linestartX, linestartY));
	 
    U = ( ( ( pointX - linestartX ) * ( lineendX - linestartX ) ) + ( ( pointY - linestartY ) * ( lineendY - linestartY ) ) ) / ( lineDistance * lineDistance );

	if (U < 0 or U > 1) then
		return 0,0;
	end
 
    intersectionPointX = linestartX + U * ( lineendX - linestartX );
    intersectionPointY = linestartY + U * ( lineendY - linestartY );
     
    return intersectionPointX,intersectionPointY;
end

function tangetpointoninfiniteline( pointX, pointY, linestartX, linestartY, lineendX, lineendY )
    local lineDistance;
    local U;
    --local intersectionPoint = vector();
	local intersectionPointX, intersectionPointY;
 
    lineDistance = dist(difference(lineendX, lineendY, linestartX, linestartY));
	 
    U = ( ( ( pointX - linestartX ) * ( lineendX - linestartX ) ) + ( ( pointY - linestartY ) * ( lineendY - linestartY ) ) ) / ( lineDistance * lineDistance );

	intersectionPointX = linestartX + U * ( lineendX - linestartX );
    intersectionPointY = linestartY + U * ( lineendY - linestartY );
     
    return intersectionPointX,intersectionPointY;
end